routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\Dashboard\Student\AllCourses\MainController as AllCoursesMain;
use App\Http\Controllers\Dashboard\Student\MyCourses\MainController as MyCoursesMain;
use App\Http\Controllers\Dashboard\Student\MyCourses\CourseController as StdCourseController;
use App\Http\Controllers\Dashboard\Student\MyCourses\MaterialController as StdMaterialController;
use App\Http\Controllers\Dashboard\Student\MyCourses\AssignmentController as StdAssignmentController;
use App\Http\Controllers\Dashboard\Creator\Dashboard\MainController as CreatorDashboardMain;
use App\Http\Controllers\Dashboard\Creator\ManageCourses\MainController as ManageCoursesMain;
use App\Http\Controllers\Dashboard\Creator\ManageCourses\CourseController as CrtCourseController;
use App\Http\Controllers\Dashboard\Creator\ManageCourses\MaterialController as CrtMaterialController;
use App\Http\Controllers\Dashboard\Creator\ManageCourses\AssignmentController;
use App\Http\Controllers\Dashboard\Creator\ManageCourses\SubmissionController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
  return view('layouts.master-landing');
});

Route::get('/me', function () {
  return view('layouts.master-dashboard');
});

Route::group([
  'as'  => 'student.',
  'prefix' => 'student'
], function () {
  Route::get('/dashboard', function () {
    return view('layouts.master-dashboard');
  })->name('dashboard.index');

  Route::get('/my-courses', [MyCoursesMain::class, 'index'])->name('my-courses.index');
  Route::get('/my-courses/{course}', [StdCourseController::class, 'show'])->name('my-courses.course.show');
  Route::get('/my-courses/{course}/material/{session}', [StdMaterialController::class, 'show'])->name('my-courses.course.material.show');
  Route::get('/my-courses/{course}/assignment/{assignment}', [StdAssignmentController::class, 'show'])->name('my-courses.course.assignment.show');

  Route::get('/all-courses', [AllCoursesMain::class, 'index'])->name('all-courses.index');
  Route::get('/all-courses/{course}', [AllCoursesMain::class, 'show'])->name('all-courses.show');
});

Route::group([
  'as'  => 'creator.',
  'prefix' => 'creator'
], function () {
  Route::get('/dashboard', [CreatorDashboardMain::class, 'index'])->name('dashboard.index');

  Route::get('/manage-courses', [ManageCoursesMain::class, 'index'])->name('manage-courses.index');

  Route::post('/manage-courses/course', [CrtCourseController::class, 'store'])->name('manage-courses.course.store');
  Route::get('/manage-courses/course/{course}', [CrtCourseController::class, 'show'])->name('manage-courses.course.show');
  Route::put('/manage-courses/course/{course}', [CrtCourseController::class, 'update'])->name('manage-courses.course.update');
  Route::delete('manage-courses/course/{course}', [CrtCourseController::class, 'destroy'])->name('manage-courses.course.destroy');
  Route::get('/manage-courses/course/{course}/create', [CrtCourseController::class, 'create'])->name('manage-courses.course.create');

  Route::get('/manage-courses/course/{course}/{assignment}', [AssignmentController::class, 'show'])->name('manage-courses.course.assignment.show');
  Route::get('/manage-courses/course/{course}/{assignment}/{assignmentSubmission}', [SubmissionController::class, 'show'])->name('manage-courses.course.assignment.submission.show');

  Route::get('/manage-courses/material/{material}', [CrtMaterialController::class, 'show'])->name('manage-courses.material.show');

  Route::get('/revenue', function () {
    return view('layouts.master-dashboard');
  })->name('revenue.index');
});

Route::group([
  'as'  => 'admin.',
  'prefix' => 'admin'
], function () {
  Route::get('/user-control', function () {
    return view('layouts.master-dashboard');
  })->name('user-control.index');
  Route::get('/transaction-history', function () {
    return view('layouts.master-dashboard');
  })->name('transaction-history.index');
});

Route::middleware([
  'auth:sanctum',
  config('jetstream.auth_session'),
  'verified'
])->group(function () {
  Route::get('/dashboard', function () {
    return view('dashboard');
  })->name('dashboard');
});

Route::group(['prefix' => 'laravel-filemanager', 'middleware' => ['web']], function () {
  \UniSharp\LaravelFilemanager\Lfm::routes();
});

app/Models/Course.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Course extends Model
{
    use HasFactory;
	
	protected $guarded = [];
	
	public function user()
	{
		return $this->belongsTo(User::class);
	}
	
	public function material()
	{
		return $this->belongsTo(Material::class);
	}
	
	public function type()
	{
		return $this->belongsTo(Type::class);
	}
	
	public function courseAssistants()
	{
		return $this->hasMany(CourseAssistant::class);
	}
	
	public function myCourses()
	{
		return $this->hasMany(MyCourse::class);
	}
	
	public function courseAssignments()
	{
		return $this->hasMany(CourseAssignment::class);
	}
	
	public function coursePrerequisites()
	{
		return $this->hasMany(CoursePrerequisite::class);
	}
	
	public function courseSuitableTargets()
	{
		return $this->hasMany(CourseSuitableTarget::class);
	}
}

app/Http/Controllers/Dashboard/Creator/ManageCourses/CourseController.php
<?php

namespace App\Http\Controllers\Dashboard\Creator\ManageCourses;

use App\Http\Controllers\Controller;
use App\Models\Course;
use App\Models\CoursePrerequisite;
use App\Models\CourseSuitableTarget;
use Illuminate\Http\Request;

class CourseController extends Controller
{
	public function create(Course $course)
	{
		return view('pages.dashboard.creator.manage-courses.course.create', compact('course'));
	}
	
	public function store()
	{
		$course = Course::create([
			'user_id' => auth()->id(),
			'description' => ''
		]);
		
		CoursePrerequisite::create([
			'course_id' => $course->id
		]);
		
		CourseSuitableTarget::create([
			'course_id' => $course->id
		]);
		
		return redirect()->route('creator.manage-courses.course.create', ['course' => $course]);
	}
	
    public function show(Course $course)
	{
		return view('pages.dashboard.creator.manage-courses.course.show', compact('course'));
	}
	
	public function destroy(Course $course)
	{
		$course->delete();
		return redirect()->route('creator.manage-courses.index');
	}
}

app/Http/Controllers/Dashboard/Student/MyCourses/CourseController.php
<?php

namespace App\Http\Controllers\Dashboard\Student\MyCourses;

use App\Models\Course;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Carbon\Carbon;

class CourseController extends Controller
{
  public function show(Course $course)
  {
    $durations = array();

    foreach ($course->courseAssignments as $index => $courseAssignment) {
      $min = $courseAssignment->duration % 60;
      if ($min < 10) {
        $min = 0 . $min;
      }

      $time = (int) ($courseAssignment->duration / 60) . ':' . $min;
      array_push($durations, Carbon::createFromFormat('H:i', $time)->format('H:i:s'));
    }

    return view('pages.dashboard.student.my-courses.course.show', compact('course', 'durations'));
  }
}

app/Http/Livewire/Dashboard/Creator/ManageCourse/Course/AssignmentEdit.php
<?php

namespace App\Http\Livewire\Dashboard\Creator\ManageCourse\Course;

use App\Models\Course;
use Livewire\Component;

class AssignmentEdit extends Component
{
  public Course $course;
  public $assignments;

  protected $rules = [
    'course.code' => 'required|string',
    'course.password' => 'required|string',
    'course.description' => 'required|string',
    'course.student_targets' => 'required|string',
    'assignments.*.score' => 'required|string',
    'assignments.*.status' => 'required|string',
    'assignments.*.duration' => 'required|integer'
  ];

  public function mount()
  {
    $this->assignments = $this->course->courseAssignments;
  }

  public function updatedAssignments($value, $key)
  {
    $this->assignments[explode('.', $key)[0]]->save();
    $this->assignments[explode('.', $key)[0]]->refresh();
  }

  public function render()
  {
    return view('livewire.dashboard.creator.manage-course.course.assignment-edit');
  }
}

app/Http/Livewire/Dashboard/Creator/ManageCourse/Course/FormCreate.php
<?php

namespace App\Http\Livewire\Dashboard\Creator\ManageCourse\Course;

use App\Models\Course;
use Livewire\Component;
use App\Models\CoursePrerequisite;
use App\Models\CourseSuitableTarget;

class FormCreate extends Component
{
	public Course $course;
	public $materials;
	public $prerequisites;
  public $suitableTargets;
	public $studentTargets;
  public $counter = 0;
	
	protected $rules = [
    'course.type_id' => 'required|integer',
    'course.material_id' => 'required|integer',
    'course.title' => 'required|string',
    'course.code' => 'required|string',
		'course.password' => 'required|string',
    'course.description' => 'required|string',
    'course.student_targets' => 'required|string',
		'course.thumbnail' => 'required|string',
		'course.images' => 'required|string',
		'course.started_at' => 'required|date',
		'course.finished_at' => 'required|date',
		'prerequisites.*.prerequisite' => 'required|string',
    'suitableTargets.*.target' => 'required|string'
    ];
	
	protected $listeners = [
    'setImage' => 'setImage',
    'setContent' => 'setContent',
		'contentUpdate' => 'contentUpdate',
		'imageUpdate' => 'imageUpdate',
		'refreshComponent' => '$refresh'
	];
	
	public function mount()
	{
		$this->materials = auth()->user()->materials;
		$this->prerequisites = $this->course->coursePrerequisites;
		$this->suitableTargets = $this->course->courseSuitableTargets;
    $this->studentTargets = $this->course->student_targets;
	}

  public function updatedCourseTitle()
  {
    $this->course->save();
  }

  public function updatedCourseCode()
  {
    $this->course->save();
  }
  
  public function updatedCoursePassword()
  {
    $this->course->save();
  }

  public function updatedPrerequisites($value, $key)
  {
    $this->prerequisites[explode('.', $key)[0]]->save();
  }

  public function updatedSuitableTargets($value, $key)
  {
    $this->suitableTargets[explode('.', $key)[0]]->save();
  }

  public function updatedCourseTypeId()
  {
    $this->course->save();
  }

  public function updatedCourseStartedAt()
  {
    $this->course->save();
  }

  public function updatedCourseFinishedAt()
  {
    $this->course->save();
  }

  public function updatedCourseMaterialId()
  {
    $this->course->save();
  }

	public function setImage($part)
	{
    $this->counter++;
		$part ? $this->dispatchBrowserEvent('fetch-image', ['thumbnail' => $this->counter]) : $this->dispatchBrowserEvent('fetch-image', ['images' => $this->counter]);
	}

	public function setContent()
	{
		$this->dispatchBrowserEvent('fetch-content', ['content' => $this->course->description]);
	}

	public function contentUpdate($description)
	{
		$this->course->description = $description;
    $this->course->save();
	}
	
	public function refreshSuitableTargets()
	{
		$this->course->refresh();
		$this->suitableTargets = $this->course->courseSuitableTargets;
	}
	
	public function addSuitableTarget()
	{
		CourseSuitableTarget::create([
			'course_id' => $this->course->id
		]);
		
		$this->refreshSuitableTargets();
	}
	
	public function deleteSuitableTarget(CourseSuitableTarget $suitableTarget)
	{
		$suitableTarget->delete();
		$this->refreshSuitableTargets();
	}

  public function refreshPrerequisites()
	{
		$this->course->refresh();
		$this->prerequisites = $this->course->coursePrerequisites;
	}

	public function addPrerequisite()
	{
		CoursePrerequisite::create([
			'course_id' => $this->course->id
		]);
		
		$this->refreshPrerequisites();
	}
	
	public function deletePrerequisite(CoursePrerequisite $prerequisite)
	{
		$prerequisite->delete();
		$this->refreshPrerequisites();
	}
	
	public function updateThumbnail($filePath)
	{
		$this->course->thumbnail = $filePath;
		$this->course->save();
		$this->course->refresh();
	}

  public function imageUpdate($filePath)
	{
		$filePath[0] ? $this->updateThumbnail($filePath[1]) : $this->updateImages($filePath[1]);
	}
	
	public function updateImages($filePath)
	{
		$this->course->images = $filePath;
		$this->course->save();
		$this->course->refresh();
	}
	
	public function publishCourse()
  {
    $this->course->student_targets = $this->studentTargets;

    $this->validate();
    $this->course->published = true;
    $this->course->save();
    foreach ($this->course->material->assignments as $index => $assignment) {
      $this->course->courseAssignments()->create([
        'assignment_id' => $assignment->id
      ]);
    }
    return redirect()->route('creator.manage-courses.index');
  }

  public function deleteCourse()
  {
    $this->course->delete();
    return redirect()->route('creator.manage-courses.index');
  }
	
    public function render()
    {
        return view('livewire.dashboard.creator.manage-course.course.form-create');
    }
}

resources/views/livewire/dashboard/creator/manage-course/course/assignment-edit.blade.php
<div x-show="open == 'assignments'" x-transition class="block">
  <div class="block my-4 rounded-lg shadow-md overflow-x-auto scrollbar">
    <table class="w-full sm:table-fixed">
      <thead class="bg-slate-100 text-xs text-dark text-center uppercase">
        <tr>
          <th class="px-4 py-3 w-1/3 md:1/5 lg:w-full xl:w-auto">Points</th>
          <th class="px-4 py-3 w-full xl:w-1/3 2xl:w-5/12">Assignment</th>
          <th class="hidden px-4 py-3 w-1/3 lg:w-full md:table-cell xl:w-auto">Duration<sub>/mins</sub></th>
          <th class="hidden px-4 py-3 w-full lg:table-cell xl:w-auto">Status</th>
          <th class="hidden px-4 py-3 w-full lg:table-cell xl:w-auto">Actions</th>
        </tr>
      </thead>

      @foreach ($assignments as $index => $assignment)
      <tbody wire:key="assignment-{{ $assignment->id }}" x-data="{expand: false}" x-on:click="expand = !expand" class="text-secondary text-left border-b">
        <tr>
          <td class="px-4 py-4 text-dark text-center">
            <input type="text" wire:model.lazy="assignments.{{ $index }}.score" x-on:click.stop class="w-10 border-0 border-b-2 border-secondary text-center p-1 focus:ring-0 focus:border-primary">
            <span class="hidden sm:inline"> / 100</span>
          </td>
          <td class="px-4 py-4">
            <div class="flex flex-nowrap items-center justify-between space-x-8 sm:space-x-4">
              <h4 class="font-medium text-dark text-md">{{ $assignment->assignment->name }}</h4>

              <span x-bind:class="{'text-primary rotate-180': expand}" class="material-symbols-outlined transition duration-300 hover:text-primary md:hidden">
                expand_more
              </span>
            </div>
          </td>
          <td class="hidden px-4 py-4 text-center md:table-cell">
            <div class="block">
              <input type="text" wire:model.lazy="assignments.{{ $index }}.duration" x-on:click.stop class="w-10 border-0 border-b-2 border-secondary text-center p-1 focus:ring-0 focus:border-primary">

              <span x-bind:class="{'text-primary rotate-180': expand}" class="material-symbols-outlined hidden transition duration-300 float-right hover:text-primary md:inline lg:hidden">
                expand_more
              </span>
            </div>
          </td>
          <td class="hidden px-4 py-4 text-center lg:table-cell">
            <button type="button" wire:click="$set('assignments.{{ $index }}.status', {{ !$assignments[$index]->status }})" x-on:click.stop class="h-4 w-8 bg-slate-100 border rounded-full py-px px-px {{ $assignment->status ? 'border-primary/80' : 'border-secondary/80' }}">
              <div class="my-auto h-3 w-3 shadow-sm rounded-full transition duration-300 {{ $assignment->status ? 'translate-x-4 bg-primary/50' : 'bg-secondary/50' }}"></div>
            </button>

            <h5 class="{{ $assignment->status ? 'text-primary' : 'text-secondary' }}">{{ $assignment->status ? 'Opened' : 'Closed' }}</h5>
          </td>
          <td class="hidden px-4 py-4 text-center lg:table-cell">
            <div x-on:click.stop class="flex flex-nowrap items-center justify-center space-x-1 py-1">
              <a href="{{ route('creator.manage-courses.course.assignment.show', ['course' => $course->id, 'assignment' => $assignment->id]) }}" title="Submission" class="flex flex-nowrap items-center p-1 bg-primary rounded-md hover:opacity-80">
                <span class="material-symbols-outlined text-white">
                  task
                </span>
              </a>

              <a href="{{ route('creator.manage-courses.material.show', ['material' => $course->material->id]) }}" title="Edit" class="flex flex-nowrap items-center p-1 bg-orange-500 rounded-md hover:opacity-80">
                <span class="material-symbols-outlined text-white">
                  edit
                </span>
              </a>
            </div>

            <div class="flex flex-nowrap items-center justify-center space-x-1 py-1">
              <span class="material-symbols-outlined font-medium text-red-500">
                info
              </span>

              <h5 class="font-medium text-xs text-red-500 whitespace-nowrap">999 Unscored</h5>
            </div>
          </td>
        </tr>

        <tr x-show="expand" x-transition class="lg:hidden">
          <td colspan="5">
            <div class="grid grid-cols-2 gap-4 p-4 sm:grid-cols-4 md:hidden">
              <h4 class="font-medium text-dark">Duration</h4>
              <span class="flex flex-nowrap space-x-2">
                <input type="text" wire:model.lazy="assignments.{{ $index }}.duration" x-on:click.stop class="w-10 border-0 border-b-2 border-secondary text-center p-0 focus:ring-0 focus:border-primary">
                <span class="inline"> / MINS</span>
              </span>
            </div>

            <div class="grid grid-cols-2 gap-4 p-4 sm:grid-cols-4">
              <h4 class="font-medium text-dark">Status</h4>
              <button type="button" wire:click="$set('assignments.{{ $index }}.status', {{ !$assignments[$index]->status }})" x-on:click.stop class="h-4 w-8 bg-slate-100 border rounded-full py-px px-px {{ $assignment->status ? 'border-primary/80' : 'border-secondary/80' }}">
                <div class="my-auto h-3 w-3 shadow-sm rounded-full transition duration-300 {{ $assignment->status ? 'translate-x-4 bg-primary/50' : 'bg-secondary/50' }}"></div>
              </button>
            </div>

            <div class="flex flex-wrap items-center p-2">
              <a href="{{ route('creator.manage-courses.course.assignment.show', ['course' => $course->id, 'assignment' => $assignment->id]) }}" title="Submission" x-on:click.stop class="flex flex-nowrap items-center justify-center mx-2 my-1 p-1 w-32 space-x-1 bg-primary rounded-md hover:opacity-80 hover:shadow-md hover:ring hover:ring-primary/70">
                <span class="material-symbols-outlined text-white">
                  task
                </span>

                <span class="text-white">
                  Submission
                </span>
              </a>

              <a href="{{ route('creator.manage-courses.material.show', ['material' => $course->material->id]) }}" title="Edit" x-on:click.stop class="flex flex-nowrap items-center justify-center mx-2 my-1 p-1 w-32 space-x-1 bg-orange-500 rounded-md text-center hover:opacity-80 hover:shadow-md hover:ring hover:ring-orange-500/70">
                <span class="material-symbols-outlined text-white">
                  edit
                </span>

                <span class="text-white">
                  Edit
                </span>
              </a>

              <div class="flex flex-nowrap items-center justify-center space-x-1 mx-2 my-1">
                <span class="material-symbols-outlined font-medium text-red-500">
                  info
                </span>

                <h5 class="font-medium text-xs text-red-500 whitespace-nowrap">999 Unscored</h5>
              </div>
            </div>
          </td>
        </tr>
      </tbody>
      @endforeach
    </table>
  </div>
</div>